QGIS Application - Bug report #15518
Issue with feature id when adding a view
2016-09-02 01:33 AM - Pablo Fernandez Moniz

Status: Closed
Priority: Normal
Assignee:

Category: Unknown

Affected QGIS version:2.14.4
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution: end of life

Copied to github as #: 23442

Description

In the table below, the configuration for the test database is provided.
table called test.tview.

CREATE EXTENSION postgis;

DROP SCHEMA IF EXISTS test CASCADE;
CREATE SCHEMA test;

--create a simple table
DROP TABLE IF EXISTS test.ttable;
create table test.ttable (
id bigint not null PRIMARY KEY,
geom geometry(Point, 32628),
name text not null,
description text);

-- create a view of test.ttable

The database has only a table called test.ttable and a view of this

CREATE OR REPLACE VIEW test.tview AS SELECT * from test.ttable where description IS NOT NULL;

GRANT ALL ON SCHEMA TEST TO postgres;
GRANT ALL ON ALL TABLES IN SCHEMA TEST TO postgres;

Database configuration

If we try to add the view as a new PostGIS layer from QGIS 2.14.4 we need to specify a feature id, otherwise we can’t add it.

http://img.fenixzone.net/i/HjMARKB.png

But if we try to add it from QGIS 2.8.1 the Primary Key is already selected by default:

http://img.fenixzone.net/i/6gAaMxo.png

It is a little bit tedious to specify a feature id when your are working with dozens of them. Is there any kind of workaround that allows to
load views directly without the need to specify their keys? Note that we cannot set a key from PostgreSQL because views cannot have

one.

History

#1 - 2016-09-02 03:04 AM - Harrissou Santanna
Hi,

I think you'll find discussions about this issue in the qgis dev or user mailing list archives (
http://osgeo-org.1560.x6.nabble.com/Quantum-GIS-f4099105.html).

My workaround is to simply use the DBManager (a core plugin you can activate from Plugin menu): faster, most featured and manage well views.

#2 - 2017-05-01 01:03 AM - Giovanni Manghi
- Easy fix? set to No
- Regression? set to No

#3 - 2017-09-22 09:55 AM - Jiirgen Fischer
- Category set to Unknown

#4 - 2019-03-09 03:08 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/

QGIS 3.4 has recently become our new Long Term Release (LTR) version. This is a major step in our history - a long term release version based on the

massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version
will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the
relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the

ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help

you plan your deployment of QGIS into an operational environment.
The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and

administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.
